import sys, os, shutil
import numpy as np
from astropy.io import ascii
import pickle
from astropy.table import Table, Column, hstack, vstack
from astropy.coordinates import SkyCoord
from astropy import units as u
from collections import Counter
from statsmodels.stats.weightstats import DescrStatsW
import statsmodels.api as sm
from copy import deepcopy
from scipy.cluster import vq
from astropy.coordinates.sky_coordinate import SkyCoord

from astropy.modeling import models, fitting
from astropy.stats import sigma_clip

import time
#start_time = time.time()

#import matplotlib
#matplotlib.use('TkAgg')
import matplotlib.pyplot as plt
#from scipy.odr import RealData,Model,ODR

class Init():
	def __init__(self, global_parameters):
		self.COMP_EXCLUDE=int(global_parameters['COMP_EXCLUDE'])
		self.MINIMUM_STARS_AUTO=int(global_parameters['MINIMUM_STARS_AUTO'])
		self.COUNT_EXCLUDE=float(global_parameters['COUNT_EXCLUDE'])
		self.MINIMUM_DATA_POINTS=int(global_parameters['MINIMUM_DATA_POINTS'])
	#, filter_list=None, catalog_path=None, tmp_dir=None):	
		#self.MIN_STARS = int(global_parameters['MIN_STARS'].strip())
		#self.SIGMA_CLIP = float(global_parameters['SIGMA_CLIP'].strip())
		#self.LIST_PARAM = global_parameters['LIST_PARAM']
		#self.CALIB_POLY = int(global_parameters['CALIB_POLY'].strip())
		#if self.CALIB_POLY>3:
			#self.CALIB_POLY=3
		#if self.CALIB_POLY<=0:
			#self.CALIB_POLY=1
			
	#def model(beta, x):
		#return beta[0]+beta[1]*x+beta[2]*x*x+beta[3]*x*x*x
	
	#def Average(self,table):
		#return table
	
	#def Diff(self,table, star_list):
		#return table
	def Unique(self, images):		
		frame=[]
		filter=[]
		for image in images:
			frame.append(image['Frame'])
			filter.append(image['Filter'])
		unique_frame=list(set(frame))
		unique_filter=list(set(filter))
		
		
		return unique_filter, unique_frame
		
	#def Unique(self, observations):
		#night=[]
		#day=[]
		#frame=[]
		#filter=[]
		#night_filter=[]
		#for observation in observations:
			#analysis=observation[5]
			#if analysis==0:
				#night.append((observation[2],observation[3], observation[4]))
				#frame.append(observation[3])
				#day.append(observation[2])import time
				#filter.append(observation[4])
				#night_filter.append((observation[2], observation[3]))
		#unique_night=list(set(night))
		
		
		
		#unique_day=list(set(day))
		#unique_frame=list(set(frame))
		#unique_filter=list(set(filter))
		
		#unique_night_frame=list(set(night_filter))
		#unique_filter.sort()
		#unique_night_frame.sort()
		
		
		#return  unique_night_frame, unique_filter
		##return  unique_night, unique_filter
	def SelectNonVar(self, table):
		non_var_table=deepcopy(table)
		rr=list(table['Var'])
		indexes = [i for i,x in enumerate(rr) if x == 'V']
		non_var_table.remove_rows(indexes)
		
		return non_var_table
	
	def list_of_stars1(self, night, dbase):
		stars=[]
		alpha=[]
		delta=[]
		all_stars=[] 
		B=[]
		V=[]
		g=[]
		r=[]
		i=[]
		
		query='SELECT jd, filename, date, frame, filter, analysis FROM observation WHERE date='+str(night[0])+' AND filter ="'+str(night[2])+'"  AND frame ="'+str(night[1])+'" ORDER BY jd'
		observations=list(dbase.ReadQuery(query))
				
		for observation in observations:			
			filename_table=observation[1]+'.match'
			table=ascii.read(filename_table)
		
			stars= stars+list(table['UCAC4'])
			alpha=alpha+list(table['RA'])
			delta=delta+list(table['DEC'])
			B=B+list(table['B'])
			V=V+list(table['V'])
			g=g+list(table['g'])
			r=r+list(table['r'])
			i=i+list(table['i'])
			#B,B_ERR,V,V_ERR,g,g_ERR,r,r_ERR,i,i_ERR
		
		unique_stars=list(set(stars))
				
		for star in unique_stars:
			index=stars.index(star)
			all_stars.append([star, alpha[index], delta[index], B[index], V[index], g[index], r[index], i[index]])
		
		#print(item)
		#print(len(item))
		
		
		#for ii in range(len(stars)):
			#item.append([stars[ii], alpha[ii], delta[ii], B[ii],V[ii],g[ii],r[ii],i[ii] ])
		#item=np.array(item)
		#tt=Table(item, names=('UCAC4','RA','DEC','B','V','g','r','i'))
		#by_name=tt.group_by(['UCAC4','RA','DEC','B','V','g','r','i'])
		#by_name.sort('UCAC4')
		#all_stars=by_name.groups.keys['UCAC4','RA', 'DEC','B','V','g','r','i']
		
	
		#print(cc)
		#print (item)
		#cc=[x[0]+x[1]+x[2]+x[3]+x[4]+x[5]+x[6]+x[7] for x in item]import time

		#print (cc)
		#for ii in item:
			#print(ii)
		#print()
		#all_stars=(set(item))
		#all_stars.sort()
		#for ii in all_stars:
			#print(ii)
		
			
		return all_stars, observations
	
		


	

	def airmass_correction(self, table_instrumetal, table_instrumetal_error, table_airmass, comparison_stars):
		return True
	
	def  instrumental_mag(self, all_stars, night, dbase):
		#instrumental_mag(self, all_stars, night, dbase):
		
		stars=list(all_stars['UCAC4'])
		jd_list=[]
		
		query='SELECT jd, filename, date, frame, filter, analysis FROM observation WHERE date='+str(night[0])+' AND filter ="'+str(night[2])+'"  AND frame ="'+str(night[1])+'" ORDER BY jd'
		observations=list(dbase.ReadQuery(query))
		
		number_stars=len(all_stars)
		number_obser=len(observations)
		
		inst_mag=np.empty((number_obser,number_stars),)
		inst_mag[:]=np.nan
		
		inst_mag_error=np.empty((number_obser,number_stars),)
		inst_mag_error[:]=np.nan
		
		airmass=np.empty((number_obser,number_stars),)
		airmass[:]=np.nan
		
		number=0
		for observation in observations:
			filename_table=observation[1]+'.match'
			filename_head=observation[1]+'.head'
		
			table=ascii.read(filename_table)
			table.meta=pickle.load(open(filename_head,"rb"))
			
			jd=table.meta['JD']			
			barCor=table['BarCor'][0]
			jd_list.append(jd+barCor)
			
			for row in table:
				index=stars.index(row['UCAC4'])
				inst_mag[number, index]=row['MAG_AUTO']
				inst_mag_error[number, index]=row['MAGERR_AUTO']
				airmass[number, index]=row['Airmass']
			number=number+1
			
		table=Table(inst_mag,names=(stars))
		table['JD_bar']=Column(jd_list)
		table_error=Table(inst_mag_error,names=(stars))
		table_error['JD_bar']=Column(jd_list)
		table_airmass=Table(airmass,names=(stars))
		table_airmass['JD_bar']=Column(jd_list)
		
		
		
		#print(inst_mag)
		return table, table_error, table_airmass
	
	def all_diff_mag1(self, stars, observations):
		number_stars=len(stars)
		number_obs=len(observations)
		mag_list=[]
		error_list=[]
		#print(stars)
		number=1
		
		for observation in observations:
			#print(observation)
			sys.stdout.write('\rPerforming differential photometry of all stars: '+str(round(number/len(observations)*100,2))+' %')
				#+str(number)+'/'+str(len(observations)))
			diff_mag=np.empty((number_stars, number_stars),)
			diff_mag_error=np.empty((number_stars, number_stars),)
			diff_mag_jd=np.empty((number_stars, number_stars,number_obs),)
			diff_mag_jd_error=np.empty((number_stars, number_stars,number_obs),)
			
			diff_mag[:]=np.nan
			diff_mag_error[:]=np.nan
			diff_mag_jd[::]=np.nan
			diff_mag_jd_error[::]=np.nan
		
			filename_table=observation[1]+'.match'
			filename_head=observation[1]+'.head'	
			new_filename_table=observation[1]+'.dm'
			new_filename_table_error=observation[1]+'.dme'
			table=ascii.read(filename_table)
			table.meta=pickle.load(open(filename_head,"rb"))
						
			jd=table.meta['JD']
			barCor=table['BarCor'][0]
			jd=jd+barCor
			
			objects=list(table['UCAC4'])
			
			
			tt_mag=np.matrix(table['MAG_AUTO'])
			tt_mag_error=np.matrix(table['MAGERR_AUTO'])
			
			diff=np.around(np.array(tt_mag-tt_mag.T), decimals=4)
			temp_tt=np.square(tt_mag_error)
			diff_error=np.around(np.array(temp_tt+temp_tt.T), decimals=4)
			
			for star in objects:
				ind=stars.index(star)
				ind1=objects.index(star)
				#print(star, ind, ind1)
				for star1 in objects:
					index=stars.index(star1)
					index1=objects.index(star1)
					diff_mag[ind][index]=diff[ind1][index1]
					diff_mag_error[ind][index]=diff_error[ind1][index1]
			
			diff_mag[0,0]=jd
			diff_mag_error[0,0]=jd
			
			
			#print(diff_mag)
			#print(diff_mag_error)
			diff_mag_jd=np.dstack((diff_mag_jd, diff_mag))
			diff_mag_jd_error=np.dstack((diff_mag_jd_error, diff_mag_error))
			
			table_diff_mag=Table(diff_mag, names=(stars))
			table_diff_mag['Stars']=Column(stars)
			table_diff_mag_error=Table(diff_mag_error, names=(stars))
			table_diff_mag_error['Stars']=Column(stars)
			#print(table_diff_mag)
			
			#print()
			#print(np.shape(diff_mag_jd))
			#print()
			#print()
			#print(diff_mag_jd[0][0][2])
			#bb=Table(diff_mag_jd, names=(stars))
			#print(bb)
			
			#table_mag=Table(diff, names=objects)
			#table_mag_error=Table(diff_error, names=objects)
			#table_diff_mag=Table(diff_mag, names=stars)
			#table_diff_mag['Stars']=Column(stars)
			#table_diff_mag[0][0]=jd
			
			#table_diff_mag_error=Table(diff_mag_error, names=stars)
			#table_diff_mag_error['Stars']=Column(stars)
			#table_diff_mag_error[0][0]=jd

			
			#for star in objects:
				#for star1 in objects:
					#index=stars.index(star1)
					#index1=objects.index(star1)
					#table_diff_mag[star][index]=table_mag[star][index1]
					#table_diff_mag_error[star][index]=table_mag_error[star][index1]
	
			
			#print(diff_mag)
			mag_list.append(table_diff_mag)
			error_list.append(table_diff_mag_error)
			###array(diff_mag, jd)		
			##tt=Table(diff_mag, names=(stars))
		
			###tt.remove_row(0)
			###tt.remove_column('000-000000')
			ascii.write(table_diff_mag,new_filename_table)
			ascii.write(table_diff_mag_error,new_filename_table_error)
			#print(table_diff_mag)
			number=number+1
			
		###for observation in observations:
			###filename_table=observation[1]+'.dm'
			###table=ascii.read(filename_table)
			###print(tt)
		#diff_mag_jd=np.dstack(mag_list)
		#diff_mag_jd_error=np.dstack(error_list)
		#print(mag_list)
		print()
		
		return mag_list, error_list
	
	def save_objects(self, table, name):
		ascii.write(table, name)
		return True
	
	def load_objects(self, name):
		return ascii.read(name)
	
	
	
	def search_in_objects(self, alpha, delta, object_table):
		for row in object_table:
			obj_alpha=row[1]
			obj_delta=row[2]
			print(obj_alpha)
		return True
	
	def list_stars_with_comparisons(self, directory):
		stars_list={}
		def is_text(filename):
			with open(filename, 'rb') as f:
				if b'\x00' in f.read():
					return False
				else:
					return True
				
		files = [os.path.join(directory,fn) for fn in next(os.walk(directory))[2]]
		for file_name in files:
			if is_text(file_name):
				f = open(file_name)			
				comp_file_lines=f.readlines()
				f.close()
				#print(comp_file_lines)
				for line in comp_file_lines:
					if not line[0]=='#' :
						line=line.rstrip()
						if not line=='':
							if line[:6].upper()=='OBJECT':
							#tmp={line[6:].replace(' ','').upper(): file_name}
								stars_list.update({line[6:].replace(' ','').upper(): file_name})
			else:
				pass
		return stars_list
	
	
	def load_comparisons(self, name):
		
		comp_stars=[]
		f = open(name)
		comp_file_lines=f.readlines()
		f.close()
		
		star_line=[]
		for line in comp_file_lines:
			
			#print(line)
			if not line[0]=='#' :
				line=line.rstrip()
				if not line=='':
					if not line[:6].upper()=='OBJECT':
						star_line.append(line)
		#execute_time=time.time() - start_time
		#print(execute_time)
		#print(star_line)
		
		def star_parameters(star_name):
			#star_name=a[0]
			tmp_star=''
			star_name=star_name.strip()			
			if '-' in star_name:
				tmp_star=(star_name)
				
			else:
				try:
					#print(star_name)
					c = SkyCoord.from_name(star_name)					
					alpha=c.ra.degree
					delta=c.dec.degree
				
					tmp_star=(alpha,delta)
					#print(alpha, delta)
				except:
					pass	
			return tmp_star 
			
			
		#execute_time=time.time() - start_time
		#print(execute_time)
		
		for star in star_line:
			a=star.split()
			#print (len(a))
			if len(a)==1:
				star_name=a[0]
				comp_stars.append(star_parameters(star_name))
			elif len(a)==2:
				star_name=a[0]
				if '-' in star_name or not ('.' in star_name or ':' in star_name):
					#determine coordinates from star name
					comp_stars.append(star_parameters(star_name))
				else:
					if ('.' in a[0] or ':' in a[0]) and ('.' in a[1] or ':' in a[1]):
						if '.' in a[0] and not ':' in a[0]:
							coord=[a[0]+ a[1]]
							c = SkyCoord(coord,unit=(u.deg, u.deg))
							#print(c)
							comp_stars.append((c.ra.degree[0], c.dec.degree[0]))
						
						else:
							coord=[a[0]+ a[1]]
							c = SkyCoord(coord,unit=(u.hourangle, u.deg))
							#print(c.ra.degree[0])
							comp_stars.append((c.ra.degree[0], c.dec.degree[0]))
							#print(c)
						
					else:
						pass
			elif len(a)==3:
				star_name=a[0]
				if '-' in star_name or not ('.' in star_name or ':' in star_name):
					#determine coordinates from star name
					comp_stars.append(star_parameters(star_name))
				else:
					if ('.' in a[1] or ':' in a[1]) and ('.' in a[2] or ':' in a[2]):
						if '.' in a[1] and not ':' in a[1]:
							coord=[a[1]+ a[2]]
							c = SkyCoord(coord,unit=(u.deg, u.deg))
							#print(c)
							comp_stars.append((c.ra.degree[0], c.dec.degree[0]))
						
						else:
							coord=[a[1]+ a[2]]
							c = SkyCoord(coord,unit=(u.hourangle, u.deg))
							#print(c.ra.degree[0])
							comp_stars.append((c.ra.degree[0], c.dec.degree[0]))
							#print(c)
						
					else:
						pass
					
				
	
		
		return comp_stars
	
	def comp_parameters(self, comp, data_table):
		TOLERANCE=0.001
		tt=deepcopy(data_table)
		
		tt.remove_rows(slice(0,len(tt)))		
			
		ucac4=list(data_table['USNO-B1.0'])
		coor=data_table['RA', 'DEC']
		ra=[]
		dec=[]
		for star in comp:
			ra.append(star[0])
			dec.append(star[1])
		
		
		c=SkyCoord(data_table['RA'], data_table['DEC'], unit=(u.deg, u.deg), frame='icrs')
		c1=SkyCoord(ra, dec, unit=(u.deg, u.deg), frame='icrs')
		
		
		for coord in c1:
			tmp=list(c.separation(coord).degree)
			idx=tmp.index(min(tmp))
			if not data_table[idx]['Var']=='V':
				tt.add_row(data_table[idx])
			
			#if any(c.separation(coord).degree<TOLERANCE):
				#print ('hhh')
		#num=1
		#for star in comp:
			#if not star=='':
				#if not len(star)==2:
					#if star in ucac4:
						#index=ucac4.index(star)
						#if not np.isnan(np.array(data_table[index])):
			  				#tt.add_row(data_table[index])
			  				
				#elif len(star)==2:
					#alpha=star[0]
					#delta=star[1]	
					#c=SkyCoord(alpha, delta, unit=(u.deg, u.deg), frame='icrs')
					#for row in coor:
						#aa=row[0]
						#dd=row[1]
						##print(num, aa,dd)
						##c1=SkyCoord(aa, dd, unit=(u.deg, u.deg), frame='icrs')
						###print(num, c1)
						##if c.separation(c1).degree<TOLERANCE:
							##index=list(coor['RA']).index(aa)
							##ml=np.array(data_table['B', 'V', 'g', 'r', 'i'][index])
							###print(ml)
							##if not np.isnan(data_table['B'][index]):
								###print()
								###print(ml)
								###print()
								##tt.add_row(data_table[index])
						#num=num+1
							
						##if aa>=(alpha-TOLERANCE) and aa<=(alpha+TOLERANCE) and dd>=(delta-TOLERANCE) and dd<=(delta+TOLERANCE):
							
							
		
		return tt
	
	def calculate_simple_diff(self, image, comparison_table, all_comp=False, absolute_calib=False):
		#all_comp - if true diff magnitudes of all comparison stars are listed into table
		#aver - if true calculate also average magnitude from stars in table comparison_stars
		#absolute_calib - if true calculate absolute magnitude using stars in table comparison_stars
		
		# calculate average comp:
				
		comp_name=comparison_table['USNO-B1.0']
		mag_comp=np.ma.array(comparison_table['MAG_AUTO'])
		magerr_comp=np.ma.array(comparison_table['MAGERR_AUTO'])
		filter=image['Filter']
		
		mag_comp_color=np.ma.array(self.determine_simple_absolute_mag(filter, comparison_table))
			
		magerr_comp_color=np.ma.array(comparison_table['MAGERR_AUTO'])
		weighted_stats = DescrStatsW(mag_comp, weights=1/magerr_comp**2, ddof=0)
		
		
		average_comp=weighted_stats.mean
		
		#print()
		#print(average_comp)
		#print()
		
		std_comp=weighted_stats.std_mean
		nobs=np.count_nonzero(~np.isnan(mag_comp))
		
		#print()
		#print(average_comp, std_comp, nobs)
		
		if nobs==1:
			average_comp=mag_comp
			std_comp=magerr_comp
		#print(average_comp, std_comp, nobs)
		#print()
		
		t=Table()	
		t_un=Table()
		
		#print(t)
				
		if not len(image['Table'])==0:
			
			#zer_point=0
			data_table=image['Table']
			mag=np.ma.array(data_table['MAG_AUTO'])
			mag_error=np.ma.array(data_table['MAGERR_AUTO'])
			
			telescope=[image['Telescope']]*len(data_table)
			camera=[image['Camera']]*len(data_table)
			observatory=[image['Observatory']]*len(data_table)
			exptime=[image['ExpTime']]*len(data_table)
			temp=[image['Temperature']]*len(data_table)	
			
			diff=mag-average_comp
			#print(diff)
			
			n_diff=np.count_nonzero(~np.isnan(diff))
			if not n_diff==len(diff):
				pass
			else:
				t['USNO-B1.0']=Column(data_table['USNO-B1.0'])				
				t['OUR']=['                        ']*len(data_table)
				#t['USNO-B1.0'].format='20s'
				t['URAT1']=Column(data_table['URAT1'])
				t['SIMBAD']=Column(data_table['SIMBAD'])
				#t['URAT1'].format='20s'
				t['RA']=Column(data_table['RA'])
				t['DEC']=Column(data_table['DEC'])
				t['RA'].format='8.5f'
				t['DEC'].format='8.5f'
				date= [(image['JD']+data_table[0]['BarCor'])]*len(data_table)
				t['JD_bar']=date
				t['JD_bar'].format='12.5f'
				filter=[image['Filter']]*len(data_table)
				t['Filter']=filter
				filter=image['Filter']
						
				t['INST']=Column(mag)
				t['INST'].format='8.4f'
				t['INST_ERROR']=Column(mag_error)
				t['INST_ERROR'].format='8.4f'
				
				
				
				t['AVER']=Column(diff)
				t['AVER'].format='8.4f'
				error=np.sqrt(mag_error**2+std_comp**2)
				t['AVER_ERROR']=Column(error)
				t['AVER_ERROR'].format='8.4f'
				
					
				if absolute_calib:
					calib_comp_mag,zero_point, count=self.determine_simple_absolute_calibration(filter, comparison_table)
					weighted_stats_color = DescrStatsW(calib_comp_mag, weights=1/magerr_comp_color**2, ddof=0)
					average_comp_color=weighted_stats_color.mean
					#if nobs==1:
					#average_comp_color=average_comp_color[0]
					diff=diff+average_comp_color
					calibrated='Y'
					nobs=count
				else:
					weighted_stats_color = DescrStatsW(mag_comp_color, weights=1/magerr_comp_color**2, ddof=0)
					average_comp_color=weighted_stats_color.mean
					#if nobs==1:
					#average_comp_color=average_comp_color[0]
					diff=diff+average_comp_color
					calibrated='N'
					zero_point=0
			#print(diff)
				t['ABS']=Column(diff)
				t['ABS'].format='8.4f'
				error=np.sqrt(mag_error**2+std_comp**2)
				t['ABS_ERROR']=Column(error)
				t['ABS_ERROR'].format='8.4f'			
			
				t['COMP_AVER']=Column([average_comp_color]*len(data_table))
				t['COMP_AVER'].format='8.4f'
				t['COMP_AVER_ERROR']=Column([std_comp]*len(data_table))
				t['COMP_AVER_ERROR'].format='8.4f'
				t['Num_Comp']=nobs
				if absolute_calib:
					t['ZERO_POINT']=zero_point
					t['ZERO_POINT'].format='8.4f'
				else:
					t['ZERO_POINT']=0
					t['ZERO_POINT'].format='8.4f'
			
				t['Observatory']=Column(observatory)
				t['Telescope']=Column(telescope)
				t['Camera']=Column(camera)
				t['Temperature']=Column(temp)
				t['Temperature'].format='4.1f'
				t['Exposure']=Column(exptime)
				t['Exposure'].format='4.1f'
				t['Calibrated']=Column(calibrated)
				
		if not len(image['Table_Un']) == 0:
			data_table_un=image['Table_Un']
			mag_un=data_table_un['MAG_AUTO']
			mag_error_un=data_table_un['MAGERR_AUTO']
			
			telescope=[image['Telescope']]*len(data_table_un)
			camera=[image['Camera']]*len(data_table_un)
			observatory=[image['Observatory']]*len(data_table_un)
			exptime=[image['ExpTime']]*len(data_table_un)
			temp=[image['Temperature']]*len(data_table_un)
			
			t_un['USNO-B1.0']=Column(data_table_un['USNO-B1.0'])
			t_un['USNO-B1.0'].format='20s'
			t_un['OUR']=['                        ']*len(data_table_un)
			#t_un['URAT1']=Column(data_table_un['URAT1'])
			#t_un['URAT1'].format='20s'
			t_un['RA']=Column(data_table_un['RA'])
			t_un['DEC']=Column(data_table_un['DEC'])
			t_un['RA'].format='8.5f'
			t_un['DEC'].format='8.5f'
			date= [(image['JD']+data_table_un[0]['BarCor'])]*len(data_table_un)
			t_un['JD_bar']=date
			t_un['JD_bar'].format='12.5f'
			filter=[image['Filter']]*len(data_table_un)
			t_un['Filter']=filter
			filter=image['Filter']
			
			t_un['INST']=Column(mag_un)
			t_un['INST'].format='8.4f'
			t_un['INST_ERROR']=Column(mag_error_un)
			t_un['INST_ERROR'].format='8.4f'
			
			diff=mag_un-average_comp
			t_un['AVER']=Column(diff)
			t_un['AVER'].format='8.4f'
			error=np.sqrt(mag_error_un**2+std_comp**2)
			t_un['AVER_ERROR']=Column(error)
			t_un['AVER_ERROR'].format='8.4f'
			
			if absolute_calib:
				calib_comp_mag,zero_point,count=self.determine_simple_absolute_calibration(filter, comparison_table)
				weighted_stats_color = DescrStatsW(calib_comp_mag, weights=1/magerr_comp_color**2, ddof=0)
				average_comp_color=weighted_stats_color.mean
				#if nobs==1:
					#average_comp_color=average_comp_color[0]
				#diff=diff+average_comp_color
				calibrated='Y'
				nobs=count
				##print(zero_point)
			else:
				weighted_stats_color = DescrStatsW(mag_comp_color, weights=1/magerr_comp_color**2, ddof=0)
				average_comp_color=weighted_stats_color.mean
				diff=diff+average_comp_color
				calibrated='N'
				zero_point=0
			t_un['ABS']=Column(diff)
			t_un['ABS'].format='8.4f'
			error=np.sqrt(mag_error_un**2+std_comp**2)
			t_un['ABS_ERROR']=Column(error)
			t_un['ABS_ERROR'].format='8.4f'
			t_un['COMP_AVER']=Column([average_comp_color]*len(data_table_un))
			t_un['COMP_AVER'].format='8.4f'
			t_un['COMP_AVER_ERROR']=Column([std_comp]*len(data_table_un))
			t_un['COMP_AVER_ERROR'].format='8.4f'
			t_un['Num_Comp']=nobs
			if absolute_calib:
				t_un['ZERO_POINT']=zero_point
				t_un['ZERO_POINT'].format='8.4f'
			else:
				t_un['ZERO_POINT']=0
				t_un['ZERO_POINT'].format='8.4f'
			
						
			t_un['Observatory']=Column(observatory)
			t_un['Telescope']=Column(telescope)
			t_un['Camera']=Column(camera)
			t_un['Temperature']=Column(temp)
			t_un['Temperature'].format='4.1f'
			t_un['Exposure']=Column(exptime)
			t_un['Exposure'].format='4.1f'
			t_un['Calibrated']=Column(calibrated)
		
		else:
			pass
		
		return t, t_un, zero_point
	
	
	def determine_simple_absolute_mag(self, filter, comparison_table):
		# Transformation by Lupton(2005)
		if filter=='B':
			tmp_mag=np.ma.array(comparison_table['B'])
			#tmp_mag_err=comparison_table['B_ERR']
		if filter=='V':
			tmp_mag=np.ma.array(comparison_table['V'])
			#tmp_mag_err=comparison_table['V_ERR']
		if filter=='R':
			r=np.ma.array(comparison_table['r'])
			i=np.ma.array(comparison_table['i'])
			tmp_mag=r-0.2936*(r-i)-0.1439
		if filter=='I':
			r=np.ma.array(comparison_table['r'])
			i=np.ma.array(comparison_table['i'])
			tmp_mag=r-1.2444*(r-i)-0.3820
		if filter=='g':
			tmp_mag=np.ma.array(comparison_table['g'])
			#tmp_mag_err=comparison_table['B_ERR']
		if filter=='r':
			tmp_mag=np.ma.array(comparison_table['r'])
			
			#tmp_mag_err=comparison_table['V_ERR']
		if filter=='i':
			tmp_mag=np.ma.array(comparison_table['i'])
			#tmp_mag_err=comparison_table['B_ERR']
		if filter=='None':
			tmp_mag=np.ma.array(comparison_table['V'])
			
		return tmp_mag
		
	def determine_simple_absolute_calibration(self, filter, comparison_table):
		mag_comp=np.ma.array(comparison_table['MAG_AUTO'])
		mag_comp_error=np.ma.array(comparison_table['MAGERR_AUTO'])
		mag_comp_color=np.ma.array(self.determine_simple_absolute_mag(filter, comparison_table))
				
		zero_point=np.nansum(mag_comp_color-mag_comp)
		count= (~np.isnan(mag_comp_color)).sum()
		zero_point=zero_point/count
		#/np.ma.count(mag_comp_color)
		calib_comp_mag=mag_comp+zero_point
		#print(calib_comp_mag)
		
		#print(tmp)
		#print((mag_comp+zero_point)-mag_comp_color)
		#print(mag_comp_color)
		#print(mag_comp_color)
		#p=np.polyfit(mag_comp, mag_comp_color,1)
		#print(p)
		#magerr_comp_color=np.array(comparison_table['MAGERR_AUTO'])
				
		return calib_comp_mag, zero_point, count
	
	
	def determine_simple_lc_identified(self, mag_tab, output=False):
		
		number=2	
		#for dd in mag_tab[0:2]:
			#print(dd['AVER'])
			
		#print(mag_tab)
		if len (mag_tab)>0:
			stack_table=mag_tab[0]
			#stack_table.pprint(max_width=-1)
			#print(stack_table)
			
			for tt in mag_tab[1:]:	
				#try:
				sys.stdout.write('\rDetermining light curves of all stars: '+str(number)+'/'+str(len(mag_tab)))
				#print(tt)
				#tmp=tt['USNO-B1.0', 'OUR']
				#print(tmp)
				stack_table=vstack([stack_table, tt])		
				#print(stack_table)
				number=number+1
				#except:
					#number=number+1
			print()	
			print('Sorting stars... ',end='')
			#print(stack_table)
			sys.stdout.flush()
			by_name=stack_table.group_by(['USNO-B1.0'])
			print('OK')
		else:
			print()
			by_name=Table()
		
		return by_name
		
	def determine_simple_lc_unidentified(self, mag_tab):
		TOLERANCE=0.001
	
			
		#if not len(mag_tab[0]) ==
		stack_table=mag_tab[0]
		
		for tt in mag_tab[1: ]:
			if not len(tt)== 0:
				tmp_table=tt
				stack_table=vstack([stack_table, tmp_table])
			
		
		by_name=stack_table.group_by(['RA', 'DEC'])
		#by_name.pprint(max_lines=-1)
		
		new_table=deepcopy(by_name)
		new_table.remove_rows(slice(0,len(new_table)))
			
			
		#print(new_table)
		while not len(by_name)==0:
			a1=by_name[0]['RA']
			d1=by_name[0]['DEC']
		
			idx=[]
			num=0
			for line in by_name:
				a=line['RA']
				d=line['DEC']
				if a>=(a1-TOLERANCE) and a<=(a1+TOLERANCE) and d>=(d1-TOLERANCE) and d<=(d1+TOLERANCE):
					idx.append(num)
					num=num+1
					line['OUR']=str(round(a1,4))+'_'+str(round(d1,4))
					new_table.add_row(line)
				
			#print(idx)		
			by_name.remove_rows(idx)
				#print(line)
		
		
		by_name_new=new_table.group_by(['OUR'])
		
		return by_name_new
	
	def Select_Stars_noNaN(self, table, minimum_stars=5, bright_percentage=60):
		new_table=deepcopy(table)
		b=np.array(table['V'])
		ind=np.argwhere(np.isnan(b))
		for idx in reversed(ind):
			new_table.remove_row(idx[0])
			
		b=np.array(new_table['Var'])
		#print(b)
		idx=[i for i, j in enumerate(b) if j == 'V']
		#print(idx)
		new_table.remove_rows(idx)
		#print(new_table)
		idx=[]
		num_rows=int(round( bright_percentage/100*len(new_table), 0))
		for i in range(num_rows+1,len(new_table)):
			idx.append(i)
		new_table.remove_rows(idx)
			
		#if len(new_table)>minimum_stars:
			#new_table.sort('V')
			
				
			#new_table.remove_rows(
			#print(idx)
			

			
			
			
		return new_table
	
	def All_Stars(self, image_list):
		all_stars=[]
		num_images=len(image_list)
		stack_table=Table()
		number=1
		for image in image_list:
			#print(image['Filter'])
			sys.stdout.flush()
			sys.stdout.write('\rCreating list of all detected stars: '+str(number)+'/'+str(len(image_list)))
			number=number+1
			tab=image['Table']
			filter=[image['Filter']]*len(image['Table'])
			jd_bar=image['JD']+image['Table']['BarCor'][0]
			
			
			tab['Filter']=filter			
			tab['JD_bar']=[jd_bar]*len(image['Table'])
			
			stack_table=vstack([stack_table, tab])
		
		print()
		#all_stars=stack_table
		by_name=stack_table.group_by(['USNO-B1.0'])
		#by_date=stack_table.group_by(['JD_bar'])
		
		#sort_stars=stack_table.group_by(['USNO-B1.0','JD_bar'])
				
		#unique_date=list(set(by_date['JD_bar']))
		#unique_date.sort()

		return by_name
	
	def Select_for_Extinction(self, all_stars, num_frames, visibility=1):
		#visibility - percentage of frame visibility 1- only stars visible on all frames are selected
		ext_stars=[]
		for star in all_stars.groups:
			if len(star)>=visibility*num_frames:
				ext_stars.append(star)
		return ext_stars
	
	def Select_for_Comparison(self, all_stars, num_frames, visibility=1):
		#visibility - percentage of frame visibility 1- only stars visible on all frames are selected
		comparison_stars=[]
		for star in all_stars.groups:
			if len(star)>=visibility*num_frames:
				if not star['Var'][0]=='V':
					comparison_stars.append(star)
		
		return comparison_stars
	
	
	
	def Select_for_Filters(self, star):
		star_filters=[]
		
		by_filter=star.group_by(['Filter'])
		
		for ff in by_filter.groups:
			star_filters.append(ff)
			
		
		return star_filters
	
	def Verify_for_Comparison(self, comparison_stars, sigma_limit=1):
		# calculate sum of squares of residuals after weighted linear fit after outliers removing
		# if large then selected limit comparison is denied 
		new_comparison_stars=[]
		fit_model_linear=models.Linear1D(slope=1, intercept=0)
		fit=fitting.LevMarLSQFitter()
		fit_outliers=fitting.FittingWithOutlierRemoval(fit, sigma_clip, niter=5, sigma=2.0)
		sum_sigma=0
		sigma=[]
		
		
		for cp in comparison_stars:	
			filtered_data, tmp_fit=fit_outliers(fit_model_linear, cp['JD_bar'], cp['MAG_AUTO'], weights=1/cp['MAGERR_AUTO']**2)
			#print(tmp_fit)
			fit_data=tmp_fit(cp['JD_bar'])
			sigma.append(np.sum((cp['MAG_AUTO']-fit_data)**2))
			#sum_sigma=sum_sigma+sigma
			
		
		if len(comparison_stars)==len(sigma):
			aver_sigma=np.median(sigma)
			std_sigma=np.std(sigma)
		
		for s in sigma:
			if s<sigma_limit*std_sigma+aver_sigma:
				idx=sigma.index(s)
				new_comparison_stars.append(comparison_stars[idx])
			
			#plt.figure()
			#plt.errorbar(cp['JD_bar'], cp['MAG_AUTO'], yerr=cp['MAGERR_AUTO'], color='red', fmt='.', ecolor='black', elinewidth=1, capsize=3)
			#plt.plot(cp['JD_bar'], tmp_fit(cp['JD_bar']))
			#plt.errorbar(cp['JD_bar'], filtered_data, color='green', fmt='.', ecolor='black', elinewidth=1, capsize=3)
		
			#plt.xlabel('X')
			#plt.ylabel('mag')
		
			#plt.show()		
		
		new_comparison_stars_list=[]
		for cp in new_comparison_stars:
			new_comparison_stars_list.append(cp['USNO-B1.0'][0])
		
		return new_comparison_stars, new_comparison_stars_list
	
	def Transformation_Coef(self, comp_table, filter=None, extinction=None):
		
		if extinction==None:
			extinction=0
			
		fit_model_linear=models.Linear1D(slope=1, intercept=0)
		fit=fitting.LevMarLSQFitter()
		fit_outliers=fitting.FittingWithOutlierRemoval(fit, sigma_clip, niter=3, sigma=2.5)
			
		comp_table['MAG_ATM'] = comp_table['MAG_AUTO']-extinction*comp_table['Airmass']			
		#stack_table=Table()	
		#for cp in comparison_stars:
			
			#stack_table=vstack([stack_table, cp])
			
		#by_date=stack_table.group_by(['JD_bar'])
		#trans_coef=[]
		#trans_coef_err=[]
		#zero_point=[]
		#zero_point_err=[]
		trans_coef = zero_point =0
		
		
		if filter=='B':
			color=comp_table['B']-comp_table['V']
			mag=comp_table['B']-comp_table['MAG_ATM']
			filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/comp_table['MAGERR_AUTO']**2)
			trans_coef=tmp_fit.slope
			zero_point=tmp_fit.intercept
			
		if filter=='V':
			color=comp_table['B']-comp_table['V']
			mag=comp_table['V']-comp_table['MAG_ATM']
			filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/comp_table['MAGERR_AUTO']**2)
			trans_coef=tmp_fit.slope
			zero_point=tmp_fit.intercept	
		if filter=='R':
			R=comp_table['r']-0.2936*(comp_table['r']-comp_table['i'])-0.1439
			color=comp_table['V']-R
			mag=R-comp_table['MAG_ATM']
			filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/comp_table['MAGERR_AUTO']**2)
			trans_coef=tmp_fit.slope
			zero_point=tmp_fit.intercept
		if filter=='I':
			I= comp_table['r']-1.2444*(comp_table['r']-comp_table['i'])-0.382
			color=comp_table['V']-I
			mag=I-comp_table['MAG_ATM']
			filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/comp_table['MAGERR_AUTO']**2)
			trans_coef=tmp_fit.slope
			zero_point=tmp_fit.intercept
			#plt.figure()
			#plt.errorbar(color, mag, color='red', fmt='.', ecolor='black', elinewidth=1, capsize=3)
			#plt.plot(color, tmp_fit(color))
			#plt.errorbar(color, filtered_data, color='green', fmt='.', ecolor='black', elinewidth=1, capsize=3)
			#plt.xlabel('B-V')
			#plt.ylabel('B-b')
			#plt.show()	
				

				
				#transformation_coef.append([date['JD_bar'], tmp_fit.slope, tmp_fit.intercept])
				
			
			##print(cp['MAG_AUTO'], cp['MAG_ATM'])
			##print(cp)
			#if filter=='B':
				#tmp_mag=np.ma.array(cp['B'])
				##tmp_mag_err=np.ma.array(cp['B_ERR'])
				#print(tmp_mag)
		return trans_coef, zero_point 
	
	def Average_Mag(self, comparison_stars):
		
	
	
		return 1
	
	def Color_Transformation(self, image, comparison_stars_list, filter=None, extinction=None):
		
		if extinction==None:
			extinction=0
			
		all_stars=list(image['Table']['USNO-B1.0'])
		#print(all_stars)
		idx=[]
		for cp in comparison_stars_list:
			if cp in all_stars:
				idx.append(all_stars.index(cp))
				
		comp_table=image['Table'][idx]
		trans_coef, zero_point=self.Transformation_Coef(comp_table, filter=filter, extinction=extinction)
		print(trans_coef, zero_point)
		
		tmp_table=image['Table']
		if filter=='B':
			tmp_table['MAG_TRANS']= (trans_coef*(tmp_table['B']-tmp_table['V'])+zero_point) - tmp_table['V']
		#color_trans_table=Table()
		#print(all_stars)
		
		return image
	
	
	def determine_lc_robust(self, all_stars, all_dates, comparison_stars, filter=None, extinction=None):
		# create light curves with average comparison star
		
		list_comparison_stars=[]
		for cp in comparison_stars:
			list_comparison_stars.append(cp['USNO-B1.0'][0])
		
		#for star in all_stars.groups:
			#print(star)
		
		fit_model_linear=models.Linear1D(slope=1, intercept=0)
		fit=fitting.LevMarLSQFitter()
		fit_outliers=fitting.FittingWithOutlierRemoval(fit, sigma_clip, niter=3, sigma=2.5)
		
		stack_table=Table()	
		for cp in comparison_stars:
			stack_table=vstack([stack_table, cp])
		by_date=stack_table.group_by(['JD_bar'])
		transformation_coef=[]
		if filter=='B':
			for date in by_date.groups:
				date['MAG_ATM'] = date['MAG_AUTO']-extinction*date['Airmass']
				color=date['B']-date['V']
				mag=date['B']-date['MAG_ATM']
				filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/date['MAGERR_AUTO']**2)
				transformation_coef.append([date['JD_bar'], tmp_fit.slope, tmp_fit.intercept])
				
				#date['MAG_TRANS']=
				#print (tmp_fit)
		if filter=='V':
			for date in by_date.groups:
				color=date['B']-date['V']
				date['MAG_ATM'] = date['MAG_AUTO']-extinction*date['Airmass']
				mag=date['V']-date['MAG_ATM']
				filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/date['MAGERR_AUTO']**2)
				transformation_coef.append([date['JD_bar'], tmp_fit.slope, tmp_fit.intercept])
				
				#print (tmp_fit)
				
				#plt.figure()
				#plt.errorbar(color, mag, color='red', fmt='.', ecolor='black', elinewidth=1, capsize=3)
				#plt.plot(color, tmp_fit(color))
				#plt.errorbar(color, filtered_data, color='green', fmt='.', ecolor='black', elinewidth=1, capsize=3)
		
				#plt.xlabel('B-V')
				#plt.ylabel('mag')
		
				#plt.show()	
		if filter=='R':
			for date in by_date.groups:
				tmp_r=date['r']
				tmp_i=date['i']
				R=tmp_r-0.2936*(tmp_r-tmp_i)-0.1439
				
				color=date['V']-R
				date['MAG_ATM'] = date['MAG_AUTO']-extinction*date['Airmass']
				mag=R-date['MAG_ATM']
				filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/date['MAGERR_AUTO']**2)
				transformation_coef.append([date['JD_bar'], tmp_fit.slope, tmp_fit.intercept])
		
				#plt.figure()
				#plt.errorbar(color, mag, color='red', fmt='.', ecolor='black', elinewidth=1, capsize=3)
				#plt.plot(color, tmp_fit(color))
				#plt.errorbar(color, filtered_data, color='green', fmt='.', ecolor='black', elinewidth=1, capsize=3)
		
				#plt.xlabel('V-R')
				#plt.ylabel('mag')
		
				#plt.show()	
		
		if filter=='I':
			for date in by_date.groups:
				tmp_r=date['r']
				tmp_i=date['i']
				I=tmp_r-1.2444*(tmp_r-tmp_i)-0.3820
								
				color=date['V']-I
				date['MAG_ATM'] = date['MAG_AUTO']-extinction*date['Airmass']
				mag=I-date['MAG_ATM']
				filtered_data, tmp_fit=fit_outliers(fit_model_linear, color, mag, weights=1/date['MAGERR_AUTO']**2)
				transformation_coef.append([date['JD_bar'], tmp_fit.slope, tmp_fit.intercept])
		
				#plt.figure()
				#plt.errorbar(color, mag, color='red', fmt='.', ecolor='black', elinewidth=1, capsize=3)
				#plt.plot(color, tmp_fit(color))
				#plt.errorbar(color, filtered_data, color='green', fmt='.', ecolor='black', elinewidth=1, capsize=3)
		
				#plt.xlabel('V-I')
				#plt.ylabel('mag')
		
				#plt.show()
		
		
		#for star in all_stars.groups:
			#by_date=star.group_by(['JD_bar'])
			#for row in by_date:
				#if 
		
		#r=np.ma.array(comparison_table['r'])
			#i=np.ma.array(comparison_table['i'])
			#tmp_mag=
		#print(by_date)
				
		
		
		# calculate transformation to standard system
		
		#for image in image_list_object:
			#print(image)
			
			
		#for cp in comparison_stars:
			#cp['MAG_ATM'] = cp['MAG_AUTO']-extinction*cp['Airmass']
			##print(cp['MAG_AUTO'], cp['MAG_ATM'])
			##print(cp)
			#if filter=='B':
				#tmp_mag=np.ma.array(cp['B'])
				##tmp_mag_err=np.ma.array(cp['B_ERR'])
				#print(tmp_mag)
		
		# calculate average magnitude
		
		return 1
	
	#if filter=='B':
			#tmp_mag=np.ma.array(comparison_table['B'])
			##tmp_mag_err=comparison_table['B_ERR']
		#if filter=='V':
			#tmp_mag=np.ma.array(comparison_table['V'])
			##tmp_mag_err=comparison_table['V_ERR']
		#if filter=='R':
			#r=np.ma.array(comparison_table['r'])
			#i=np.ma.array(comparison_table['i'])
			#tmp_mag=r-0.2936*(r-i)-0.1439
		#if filter=='I':
			#r=np.ma.array(comparison_table['r'])
			#i=np.ma.array(comparison_table['i'])
			#tmp_mag=r-1.2444*(r-i)-0.3820
		#if filter=='g':
			#tmp_mag=np.ma.array(comparison_table['g'])
			##tmp_mag_err=comparison_table['B_ERR']
		#if filter=='r':
			#tmp_mag=np.ma.array(comparison_table['r'])
			
			##tmp_mag_err=comparison_table['V_ERR']
		#if filter=='i':
			#tmp_mag=np.ma.array(comparison_table['i'])
			##tmp_mag_err=comparison_table['B_ERR']
		#if filter=='None':
			#tmp_mag=np.ma.array(comparison_table['V'])
			
	
	
	def Atmospheric_Extinction(self, comparison_stars):
		
		aver_k=0
		fit_model_linear=models.Linear1D(slope=1, intercept=0)
		fit=fitting.LevMarLSQFitter()
		fit_outliers=fitting.FittingWithOutlierRemoval(fit, sigma_clip, niter=3, sigma=2.0)
		kv=[]
		for cp in comparison_stars:
			filtered_data, tmp_fit=fit_outliers(fit_model_linear, cp['Airmass'], cp['MAG_AUTO'], weights=1/cp['MAGERR_AUTO']**2)
			kv.append(tmp_fit.slope)
			
			#err=np.absolute(fit.fit_info['cov_x'][0][0])**0.5
			#print(tmp_fit.slope, err)
			#plt.figure()
			#plt.errorbar(cp['Airmass'], cp['MAG_AUTO'], yerr=cp['MAGERR_AUTO'], color='red', fmt='.', ecolor='black', elinewidth=1, capsize=3)
			#plt.plot(cp['Airmass'], tmp_fit(cp['Airmass']))
			#plt.errorbar(cp['Airmass'], filtered_data, color='green', fmt='.', ecolor='black', elinewidth=1, capsize=3)
		
			#plt.xlabel('X')
			#plt.ylabel('mag')
		
			#plt.show()	
		aver_k=np.average(kv)
		std_k=np.std(kv)
		
		
		return aver_k, std_k
	
	
	
	
	def select_stars_extinction(self, table_instrumetal):
		
		cols=[]
		part=0*len(table_instrumetal)
		table_full=table_instrumetal
			
		for column in table_instrumetal.colnames:
			if not column=='JD_bar':
				rr=np.array(list(table_instrumetal[column]))
				if len(np.where(np.isnan(rr))[0])>part:
					cols.append(column)
		table_full.remove_columns(cols)
		table_full.remove_column('JD_bar')
		extinction_stars=table_full.colnames
				
			
		#print(extinction_stars_table)
		
		return extinction_stars
	
	def select_stars_extinction_totable(self, extinction_stars, table_instrumetal, table_instrumetal_error):
		extinction_stars_table=[]
		
		extinction_stars_table=Init.comparison_to_table(self, extinction_stars, table_instrumetal, table_instrumetal_error)
	
		return extinction_stars_table
	
	def select_auto_comparisons(self, object_file, table_instrumetal, table_instrumetal_error):
		rr=[]
		
		comparison_stars=[]
		object_table=self.load_objects(object_file)
		tmp_object_table=object_table
		table_full=table_instrumetal
		
		num=0			
		index=[]
			
		# selecting stars with defined BVgri magnitudes 
		for row in object_table:
			rr=np.array(list(row)[3:])
			if len(np.where(np.isnan(rr))[0])>0:
				index.append(num)
			num=num+1
				
		tmp_object_table.remove_rows(index)
		
		#print(tmp_object_table)
		# selecting stars which are detected on all frames
		num=0
		cols=[]
		part=self.COUNT_EXCLUDE*len(table_instrumetal)
		
		for column in table_instrumetal.colnames:
			if not column=='JD_bar':
				rr=np.array(list(table_instrumetal[column]))
				if len(np.where(np.isnan(rr))[0])>part:
					cols.append(column)
					
		table_full.remove_columns(cols)
		objects=tmp_object_table['UCAC4']
		
			# selecting stars detected on all frames with BVgri magnitudes
		for col in table_full.colnames:
			if col in objects:	
					#col.meta['B']=
				comparison_stars.append(col)
					
		# remove variable stars
		return comparison_stars
	
	
		#comparisons_table=Init.remove_var_from_comparisons(self, comparisons_table)
		
		##set final weight
		#comparisons_table=Init.set_weights(self, comparisons_table)
		##for x in comparisons_table:
			##print(x.meta['Weight'])
		## set magnitudes from BVgri
		#comparisons_table=Init.set_calib_mag(self, comparisons_table, object_file)		
		##print(comparisons_table)
		
	
	
	def remove_var_from_comparisons(self, comparisons_table):
		# remove variabloe stars and outliers from comparisons 
		std_v=[]
		aver_m=[]
		new_comparisons_table=[]
		std_v_new=[]
		for star in comparisons_table:
			y=np.array(star['MAG_AUTO'])
			err=np.array(star['MAGERR_AUTO'])
			y=np.ma.masked_invalid(y)
			err=np.ma.masked_invalid(err)
			#weighted_stats = DescrStatsW(y, weights=1/err**2, ddof=0)
			#average=weighted_stats.mean
			average =np.ma.average(y, weights=1/err**2)
			variance=np.ma.average((y-average)**2, weights=1/err**2) 
			std=np.ma.sqrt(variance)
			
			#std=weighted_stats.std
			std_v.append(std)
			aver_m.append(average)				
			
		
				
		aver_m=np.array(aver_m)
		#weighted_stats = DescrStatsW(std_v, weights=1/aver_m**2, ddof=0)
		std_aver=np.ma.average(std_v)
	
		index=0
		for std in std_v:
			if std<=std_aver*1.1:
				new_comparisons_table.append(comparisons_table[index])
				std_v_new.append(std)
			index=index+1			
		
		return new_comparisons_table
	
	
	def set_weights(self, comparisons_table):
		std_v=[]
		aver_m=[]
		new_comparisons_table=[]
		std_v_new=copmarison_stars
		for star in comparisons_table:
			y=np.array(star['MAG_AUTO'])
			err=np.array(star['MAGERR_AUTO'])
			y=np.ma.masked_invalid(y)
			err=np.ma.masked_invalid(err)
			
			#weighted_stats = DescrStatsW(y, weights=1/err**2, ddof=0)
			average =np.ma.average(y, weights=1/err**2)
			variance=np.ma.average((y-average)**2, weights=1/err**2) 
			std=np.ma.sqrt(variance)
			
			#average=weighted_stats.mean
			#std=weighted_stats.std
			std_v.append(std)
			aver_m.append(average)				
			star.meta['Weight']=1/std**2+10/average**2
			new_comparisons_table.append(star)	
		return new_comparisons_table
	   
	
	def set_calib_mag(self, comparisons_table, object_file):
		new_comparisons_table=[]
		object_table=self.lomag_averad_objects(object_file)
		object_names=list(object_table['UCAC4'])
		for star in comparisons_table:
			if star.meta['Star'] in object_names:
				index=object_names.index(star.meta['Star'])				
				star.meta['B']=object_table['B'][index]
				star.meta['V']=object_table['V'][index]
				star.meta['g']=object_table['g'][index]
				star.meta['r']=object_table['r'][index]
				star.meta['i']=object_table['i'][index]
				new_comparisons_table.append(star)	
				
		return new_comparisons_table
	
	
	
	def all_diff_mag(self, table_instrumetal, table_instrumetal_error, table_average_comp):
		mag_aver=np.array(table_average_comp['MAG_AVER'])
		mag_error_aver=np.array(table_average_comp['MAGERR_AVER'])
		jd=np.array(table_average_comp['JD_bar'])
		table_aver=Table()
		table_aver_error=Table()
		table_aver['JD_bar']=jd
		for column in table_instrumetal.colnames:
			if not column=='JD_bar':
				mag=np.array(table_instrumetal[column])
				err=np.array(table_instrumetal_error[column])
				diff=mag-mag_aver
				diffe=np.sqrt(err**2+mag_error_aver**2)
				table_aver[column]=diff
				table_aver[column+'_err']=diffe
				
				#print(column)
				#print(diff)
				#print()
		
		return table_aver
		
	
	def comparison_to_table(self, comparison_stars, table_instrumetal, table_instrumetal_error):
		comp_magnitudes=[]		
		
		#print(table_instrumetal)
		for star in comparison_stars:
			
			tt=table_instrumetal['JD_bar', star]
			tt_e=table_instrumetal_error['JD_bar',star]
			#print(len(tt), len(tt_e))
			table=hstack([tt, tt_e])
			table.remove_column('JD_bar_2')
			table.rename_column('JD_bar_1', 'JD_bar')
			table.rename_column(star+'_1', 'MAG_AUTO')
			table.rename_column(star+'_2', 'MAGERR_AUTO')	
			table.meta['Star']=star
			comp_magnitudes.append(table)
			
		return comp_magnitudes
	
	
	#def select_comparisons_byNaN(self, comparison_stars, table_instrumetal):
		#new_stars=[]	
		##cmp_stars=[]
		##for star in comparison_stars:
			##cmp_stars.append(star[0])
			
		#for star in comparison_stars:
			#tt=table_instrumetal['JD_bar', star]
			#y=np.array(tt[star])
			#nan_values=np.where(np.isnan(y))			
			#if len(nan_values[0]) < self.COMP_EXCLUDE:
				#new_stars.append(star)
		
		#return new_stars
	
	#def select_comparisons_bySTD(self, comp_magnitudes, table_instrumetal,table_instrumetal_error, coef=1.2):
		#new_stars=[]	
		#std_v=[]
		
		#for star in comp_magnitudes:
			
			#y=np.array(star['MAG_AUTO'])
			#err=np.array(star['MAGERR_AUTO'])
			#y=np.ma.masked_invalid(y)	
			#err=np.ma.masked_invalid(err)
			
			#average=np.ma.average(y,weights=1./err)
					
			#std=np.ma.sqrt(np.ma.average((y-average)**2,weights=1./err))
			#std_v.append(std)		
			
		#std_aver=np.average(std_v)
		#std_v_new=[]
		#index=0
		#for std in std_v:
			#if std<=std_aver*coef:
				#new_stars.append(comp_magnitudes[index])
				#std_v_new.append(std)
			#index=index+1		
		
		#return new_stars, std_v_new
	
	#def calculate_average_comparison_mag(self, comparisons_table):
		#table_average_comparison=Table()
		#jd_bar=comparisons_table[0]['JD_bar']
		
		#all_table=Table()
		#all_table['JD_bar']=Column(jd_bar)
		
		
		##tt=star['JD_bar', 'MAG_AUTO']
		##tt_e=star['JD_bar','MAGERR_AUTO']
		##table=hstack([tt, tt_e])
		#num=0
		#cmp_stars=[]
		#num_stars=[]
		#weight=[]
		#B=[]
		#V=[]
		#g=[]
		#r=[]
		#i=[]
		#for star in comparisons_table:
			#star_name=star.meta['Star']
			#cmp_stars.append(star_name)
			#weight.append(star.meta['Weight'])
			#B.append(star.meta['B'])
			#V.append(star.meta['V'])
			#g.append(star.meta['g'])
			#r.append(star.meta['r'])
			#i.append(star.meta['i'])
			#tt=star['MAG_AUTO']copmarison_stars
			#all_table[star_name+'_'+str(num)]=Column(tt)
			##tt=star['MAGERR_AUTO']
			##all_table[star_name+'_'+str(num)+'_e']=Column(tt)
			#num=num+1
		
		#all_table.remove_column('JD_bar')
		#weight=np.array(weight)
		#B=np.array(B)	
		#V=np.array(V)	
		#g=np.array(g)	
		#r=np.array(r)	
		#i=np.array(i)	
		#mag=[]
		#err=[]
		##print(weight)
		#for row in all_table:
			#rr=np.array(list(row))	
			#nan_values_index=np.argwhere(np.isnan(rr))
			#rr= np.delete(rr,nan_values_index)
			#if len(rr)>self.MINIMUM_STARS_AUTO:
				#num_stars.append(len(rr))
				#tmp_weights=np.delete(weight, nan_values_index)
				#weighted_stats = DescrStatsW(rr, weights=tmp_weights, ddof=0)
				#average=weighted_stats.mean			
				#mag.append(average)
			#else:
				#mag.append(np.nan)
				#num_stars.append(np.nan)
			
		#all_table=Table()
		#all_table['JD_bar']=Column(jd_bar)
		#for star in comparisons_table:			
			#tt=star['MAGERR_AUTO']
			#all_table[star_name+'_'+str(num)+'_e']=Column(tt)
			#num=num+1
		#all_table.remove_column('JD_bar')		
		#for row in all_table:
			#rr=np.array(list(row))
			#nan_values_index=np.argwhere(np.isnan(rr))
			#rr= np.delete(rr,nan_values_index)
			#tmp_weights=np.delete(weight, nan_values_index)			
			#weighted_stats = DescrStatsW(rr, weights=tmp_weights, ddof=0)
			#average=weighted_stats.std_mean
			#err.append(average)
		
		#table_average_comparison['JD_bar']=Column(jd_bar)
		#table_average_comparison['MAG_AVER']=Column(mag)
		#table_average_comparison['MAGERR_AVER']=Column(err)
		#table_average_comparison['NUM_STARS']=Column(num_stars)
		
		#weighted_stats = DescrStatsW(B, weights=weight, ddof=0)
		#table_average_comparison.meta['B']=weighted_stats.mean
		#weighted_stats = DescrStatsW(V, weights=weight, ddof=0)
		#table_average_comparison.meta['V']=weighted_stats.mean
		#weighted_stats = DescrStatsW(g, weights=weight, ddof=0)
		#table_average_comparison.meta['g']=weighted_stats.mean
		#weighted_stats = DescrStatsW(r, weights=weight, ddof=0)
		#table_average_comparison.meta['r']=weighted_stats.mean
		#weighted_stats = DescrStatsW(i, weights=weight, ddof=0)
		#table_average_comparison.meta['i']=weighted_stats.mean
		
		#return table_average_comparison
		
	
	#def average_mag(self, table_above_atm, table_above_atm_error, table_average_comparison, filter):
		#table_average=Table()
		#table_average_calib=Table()
		#jd_bar=table_above_atm['JD_bar']		
		#table_average['JD_bar']=Column(jd_bar)
		#table_average['JD_bar'].format='8.5f'
		#table_average_calib['JD_bar']=Column(jd_bar)
		#table_average_calib['JD_bar'].format='8.5f'
		#table_average['NUM_STARS']=table_average_comparison['NUM_STARS']
		#table_average_calib['NUM_STARS']=table_average_comparison['NUM_STARS']
		
		#for column in table_above_atm.colnames :
			#if not column=='JD_bar':
				#col=np.array(table_above_atm[column])
				#col_err=np.array(table_above_atm_error[column])
				##col_err=np.ma.masked_invalid(col_err)	
				
				#mag_c=np.array(table_average_comparison['MAG_AVER'])
				#err_c=np.array(table_average_comparison['MAGERR_AVER'])		
				
				#mag=col-mag_c
				#error=np.sqrt(col_err**2+err_c**2)
							
				#table_average[column]=mag
				#table_average[column].format='6.4f'
				#table_average[column+'_err']=error
				#table_average[column+'_err'].format='6.4f'
				#calib_mag=Init.calibrate(self, filter, table_average_comparison)
				#mag=mag+calib_mag
				
				#table_average_calib[column]=mag
				#table_average_calib[column+'_err']=error
				#table_average_calib[column].format='6.4f'
				#table_average_calib[column+'_err'].format='6.4f'
				
				
		#return table_average, table_average_calib
	
	#def calibrate(self, filter, table_average_comparison):
		
		## transformation from Lupton(2005)
		
		#if filter=='B':
			#mag=table_average_comparison.meta['B']
		#if filter=='V':
			#mag=table_average_comparison.meta['V']
		#if filter=='R':unique_filter=list(set(ff))

			#r=table_average_comparison.meta['r']
			#i=table_average_comparison.meta['i']
			#mag=r-0.2936*(r-i)-0.1439
		#if filter=='I':
			#r=table_average_comparison.meta['r']
			#i=table_average_comparison.meta['i']
			#mag=r-1.2444*(r-i)-0.3820
		#if filter=='g':
			#mag=table-table_average_comparison.meta['g']
		#if filter=='r':
			#mag=table-table_average_comparison.meta['r']
		#if filter=='i':
			#mag=table-table_average_comparison.meta['i']
		
		#return mag
	
	
	#def average_mag_comp(self, comparison_stars, table_instrumetal, table_instrumetal_error):
		
		
		#std_v=[]
				
		#initial_number=len(comparison_stars)
		#print('Selecting proper comparison stars...')
		
		#comparison_stars=Init.select_comparisons_byNaN(self, comparison_stars, table_instrumetal)
		#comp_magnitudes=Init.comparison_to_table(self, comparison_stars, table_instrumetal, table_instrumetal_error)
		
		#comp_magnitudes, std_v=Init.select_comparisons_bySTD(self, comp_magnitudes, table_instrumetal,table_instrumetal_error, coef=1.1)
		
		#if initial_number-len(comp_magnitudes)==0:
			#print('All comparison stars are used')
		#else:
			#print('Excluded comparison stars: ',initial_number-len(comp_magnitudes) )


		#yy=np.zeros(len(table_instrumetal))
		#error=np.zeros(len(table_instrumetal))
		##table_aver=table_instrumetal['JD_bar', comparison_stars[0]]
		###print(table_aver)
		
		#std=np.array(std_v)
		#norm_err=std/std.max()
		
		
		#comparison_stars_new=[]
		
		#table_aver=comp_magnitudes[0]
		#table_aver_err=comp_magnitudes[0]
		
		#num=0
		#rem_name=[]
		#jd=list(comp_magnitudes[0]['JD_bar'])
		#for star in comp_magnitudes:
			##print(star)
			
			#tt=star['JD_bar','MAG_AUTO']
			#tt_err=star['JD_bar','MAGERR_AUTO']
			#tt.rename_column('JD_bar','JD'+str(num))
			#tt_err.rename_column('JD_bar','JD'+str(num))
			#rem_name.append('JD'+str(num))
			#tt.rename_column('MAG_AUTO','col'+str(num))
			#tt_err.rename_column('MAGERR_AUTO','col'+str(num))
			#table_aver=hstack([table_aver, tt])
			#table_aver_err=hstack([table_aver_err, tt_err])
			#num=num+1
			##table_aver=table_instrumetal['JD_bar', comparison_stars[0]]
			##tt=
		#table_aver.remove_columns(['MAG_AUTO','MAGERR_AUTO'])
		#table_aver.remove_columns(rem_name)
		#table_aver_err.remove_columns(['MAG_AUTO','MAGERR_AUTO'])
		#table_aver_err.remove_columns(rem_name)
		
		#tmp_table=table_aver
		#tmp_table.remove_column('JD_bar')
		#tmp_table_err=table_aver_err		
		#tmp_table_err.remove_column('JD_bar')
		#average=[]
		#err=[]
		
		#for row, row_e in zip(tmp_table, tmp_table_err):
			#rr=np.array(list(row))
			#rr_err=np.array(list(row_e))
			#weight=1/(norm_err*rr_err)
			
			#weighted_stats = DescrStatsW(rr, weights=weight, ddof=0)
			#average.append(weighted_stats.mean)
			#err.append(weighted_stats.std_mean)
			##average=np.average(rr,weights=norm_err)
			##err=np.sqrt( rr-average)**2
			##err=np.sqrt(np.average((rr-average)**2,weights=norm_err))
		#tt=Table()
		#tt['JD_bar']=jd
		#tt['MAG_AVER']=average
		#tt['MAGERR_AVER']=err
		##tt['COUNT']=num
		#table_aver=tt
				
		#return table_aver, comparison_stars, norm_err
	
	def atmospheric_extinction(self, table_instrumetal, table_instrumetal_error, table_airmass, comparisons_table):
		stars=[]
		k=[]
		k_err=[]
		table_above_atm=Table()
		table_above_atm_error=Table()

		table_above_atm['JD_bar']=table_instrumetal['JD_bar']
		#table_above_atm_error['JD_bar']=table_instrumetal['JD_bar']
		
		table_above_atm_error=table_instrumetal_error
		
		for star in comparisons_table:
			star_name=star.meta['Star']
			mag=np.array(table_instrumetal[star_name])
			err=np.array(table_instrumetal_error[star_name])
			airmass=np.array(table_airmass[star_name])

			#nan_values_index=np.argwhere(np.isnan(mag))
			#mag= np.delete(mag,nan_values_index)
			
			#nan_values_index=np.argwhere(np.isnan(err))
			#err= np.delete(err,nan_values_index)
			
			#nan_values_index=np.argwhere(np.isnan(airmass))
			#airmass= np.delete(airmass,nan_values_index)
			#mag=np.ma.masked_invalid(mag)
			err=np.ma.masked_invalid(err)
			airmass=np.ma.masked_invalid(airmass)
			if len(mag)>self.MINIMUM_DATA_POINTS:
				ff, cov=np.ma.polyfit(airmass, mag,1, w=1/err**2, cov=True)
				
				k.append(ff[0])
				k_err.append(np.sqrt(np.diag(cov))[0])
			else:
				#print('Not enought stars for calculation. Need>', self.MINIMUM_DATA_POINTS)
				pass
		if len(k)==0:
			aver_k=0
			aver_k_err=0
		else:
			k=np.array(k)
			k_err=np.array(k_err)		
			weighted_stats = DescrStatsW(k, weights=1/k_err**2, ddof=0)
			aver_k=weighted_stats.mean
			aver_k_err=weighted_stats.std_mean
		
		for star in table_instrumetal.colnames:
			if star=='JD_bar':
				pass
			else:
				airmass=np.array(table_airmass[star])
				mag=np.array(table_instrumetal[star])
				err=np.array(table_instrumetal_error[star])
				mag0=mag-aver_k*airmass
				#err0=np.sqrt(err**2 +(abs(aver_k*airmass)*(aver_k_err/aver_k))**2)
				table_above_atm.add_column(Column(mag0, name=star))	
				table_above_atm[star].format='6.4f'
				#table_above_atm_error.add_column(Column(err0, name=star))
		table_above_atm.meta=table_instrumetal.meta
		table_above_atm.meta['k'] =aver_k
		table_above_atm.meta['k_err'] =aver_k_err
		
			
		return table_above_atm,table_above_atm_error
	
